<html>
<head>
<title>RManNotes: Stochastic Patterns: Bombing</title>
</head>

<body bgcolor="#f9f9b1" background="notepad.gif" link="801010" vlink="101080" alink="108010"> <img alt="RManNotes" align=center src="header.gif">

<img align=center hspace=10 src="stoch_patterns.gif">

<p><img src="black_line.gif"></p>
<p>
<a href="perturbed.html">previous</a>
|
<i>next</i>
|
<a href="index.html">stochastic patterns: <b>contents</b></a>
|
<a href="../index.html">rmannotes: <b>top</b></a>
</i>
</p>
<p><img src="black_line.gif"></p>

<h1>Bombing!</h1>

<p>
Another way to add randomness to regular patterns is to use a technique 
called <i>bombing</i>. Bombing generates 
<i>random placement patterns</i> -- regular patterns or features which are "dropped" at random positions or orientations in texture space.
</p>

<p>
We start out with a regular pattern composed of diamonds (rotated 
<a href="../RegularPatterns/shapes.html#rectangles">squares</a>).
</p>

<p align=center><img src="rotblocks.1.gif">
<br><a href="rotblocks.sl">rotblocks.sl</a></p>

<p>
Then using the bombing technique, we randomly move the position of
each diamond. The key here, and the thing that distinguishes it
from a <a href="perturbed.html">perturbed regular pattern</a>, is
that <i>the shifting is based on the 
<a href="../RegularPatterns/mod.html#which">tile coordinates</a>
(column & row of the tile)</i> and not the texture coordinates. By
using the tile coordinates as the seed (input) to 
<a href="noise.html">noise</a>, we get the same pseudo-random value
(ouput) for every point inside that tile. And that's why the 
regular shape is maintained. If different random 
values are obtained within each tile, the diamond shapes will become irregular
in shape.
</p>

<p>
To reiterate, the randomness must be 
based on tile coordinates (<code>col,row</code>) -- 
because (<code>col,row</code>) are constant for each tile --
and not on texture coordinates (<code>ss,tt</code>) or some
other variable (e.g. <code>s,t</code>) which varies within each tile.
</p>

<p align=center><img src="rotblocks.2.gif">
<br><a href="rotblocks.2.sl">rotblocks.2.sl</a></p>

<p>
Other parameters can also
be based on tile coordinates. In the example below, we use
<a href="noise.html#udn">udn</a> to randomly discard tiles and to
randomly choose tile colors. Note that the seeds (inputs) to <code>udn</code>
are large -- that way neighboring tiles have uncorrelated randomness.
In general, <code>udn</code> is useful when noise is not being used for pattern generation, but rather 
for making some random choice. For example, when bombing shapes, several attributes might be randomly chosen using udn:
<ul>
<li>location;
<li>orientation (degrees rotated);
<li>shape (e.g. the number of points on a star);
<li>color; or
<li>existence (e.g. only generate a tile 30% of the time).
</ul>
</p>

<p align=center><img src="rotblocks.3.gif">
<br><a href="rotblocks.3.sl">rotblocks.3.sl</a></p>

<p>
Finally, we can generate many layers of the now randomized 
diamond pattern using a for-loop. The loop index controls the size 
of the diamonds (the frequency of the layer), adjusts the fuzz
factor, and is a factor in the
seeds to <code>udn</code> so that each layer is completely unique.
</p>

<p align=center><img src="rotblocks.4.gif">
<br><a href="rotblocks.4.sl">rotblocks.4.sl</a></p>

<p><img src="black_line.gif"></p>
<p>
<a href="perturbed.html">previous</a>
|
<i>next</i>
|
<a href="index.html">stochastic patterns: <b>contents</b></a>
|
<a href="../index.html">rmannotes: <b>top</b></a>
</i>
</p>

<p><img src="black_line.gif"></p> <small> <p><i>RManNotes</i> is Copyright &copy; 1995, 1996 Stephen F. May</p> <p> <i>Any comments or suggestions appreciated.</i> <address><a href="http://www.cgrg.ohio-state.edu/~smay">Steve May</a> (<a href="mailto:smay@cgrg.ohio-state.edu">smay@cgrg.ohio-state.edu</a>)</address> </p> </small>

<p align=right><small><i>Last Modified: 4/16/96</i></small></p>

</body>
</html>
